/*
Code by Marcin Ignac 2010
http://marcinignac.com
*/

import javax.media.opengl.*; 
import javax.media.opengl.glu.*;

class Camera {
  void save() {
    GL gl = ((PGraphicsOpenGL)g).gl; 
    gl.glMatrixMode(GL.GL_PROJECTION);
    gl.glPushMatrix();
    gl.glMatrixMode(GL.GL_MODELVIEW);
    gl.glPushMatrix();
  }
  
  void restore() {
    GL gl = ((PGraphicsOpenGL)g).gl; 
    gl.glMatrixMode(GL.GL_PROJECTION);
    gl.glPopMatrix();
    gl.glMatrixMode(GL.GL_MODELVIEW);
    gl.glPopMatrix();
  }
  
  void perspective(float fov, float ratio, float near, float far) {
    GL gl = ((PGraphicsOpenGL)g).gl; 
    GLU glu = ((PGraphicsOpenGL)g).glu;
    
    //gl.glViewport(0, 0, width, height);
    
    gl.glMatrixMode(GL.GL_PROJECTION);
    gl.glLoadIdentity();	
    
    glu.gluPerspective(fov, ratio, near, far);
    
    gl.glMatrixMode(GL.GL_MODELVIEW);
    gl.glLoadIdentity();
  }
  
  void lookAt(Vec3 eye, Vec3 target, Vec3 up) {
    GLU glu = ((PGraphicsOpenGL)g).glu;
    glu.gluLookAt(
      eye.getX(), eye.getY(), eye.getZ(),
      target.getX(), target.getY(), target.getZ(),
      up.getX(), up.getY(), up.getZ()
    );
  } 
}
